local myname="ZifnabsScheduler"
local Me=CreateFrame("Frame",myname)
if not ZifnabsMod then ZifnabsMod={scheduler=Me} else ZifnabsMod.scheduler=Me end
local mod
local L
local db

local online=0
local tick=0
local fps={value=0,update=0}
local widget={}
local schedule={[1]={at=9999999999,id=nil,script=nil}}
local remind={id=0}

-- bandwidthInKB, bandwidthOutKB, latencyHomeMS, latencyWorldMS = GetNetStats()

-- --------------------------------------------------------------------------------------
-- INITIALIZE
-- --------------------------------------------------------------------------------------
function Me:Initialize(fwinfo)
	ZifnabsFW=fwinfo
	mod=fwinfo.mod
	L=fwinfo.L
	db=fwinfo.db
	if not db.scheduler then db.scheduler={fps={min=30,max=60,show=true}} end
	if not db.scheduler.fps or db.scheduler.fps.show==nil then db.scheduler.fps.show=true end -- ab r191222a+
	
	widget.fpstext=mod.ui:addText(myname.."_FPS_Text",32,10,fwinfo.frame,"TOPRIGHT","TOPRIGHT",-4,-6,11,"RIGHT")
	
	mod.core:Register4Event("ONUPDATE","scheduler",Me.OnUpdate)
end

-- --------------------------------------------------------------------------------------
-- ON UPDATE
-- --------------------------------------------------------------------------------------
function Me:OnUpdate(elapsed)
	online=online+elapsed
	if online>=tick+0.1 then 
		mod.core:OnEvent("TICK",online-tick,online) 
		tick=online
	end

	if schedule[1].at<=time() then
		local command=schedule[1].script
		tremove(schedule,1)
		local command=gsub(command or "","[*][.]mod[.]","ZifnabsFW.mod.")
		local command=gsub(command or "","[*][.]L[.]","ZifnabsFW.L.")
		assert(loadstring(command))()
	end

	-- show FPS
	if db.scheduler.fps.show then
		if online>=fps.update+1 then
			local colorrange=(db.scheduler.fps.max-db.scheduler.fps.min)/2
			local red=min(colorrange,max(0,db.scheduler.fps.max-fps.value))/colorrange
			local green=min(colorrange,max(0,fps.value-db.scheduler.fps.min))/colorrange
			widget.fpstext:SetText(fps.value)
			widget.fpstext:SetTextColor(red,green,0,1)
			fps.value=0
			fps.update=online
		end
		fps.value=fps.value+1	
	end
end

-- --------------------------------------------------------------------------------------
-- ADD
-- --------------------------------------------------------------------------------------
function Me:add(after,id,script)
	local at=time()+after
	for i=1,999,1 do
		if schedule[i] and schedule[i].id==id then tremove(schedule,i) end
	end
	for i=1,999,1 do
		if schedule[i].at>at then
			tinsert(schedule,i,{at=at,id=id,script=script})
			break
		end
	end
end

-- --------------------------------------------------------------------------------------
-- REMIND
-- --------------------------------------------------------------------------------------
function Me:Remind(seconds,text)
	Me:add(seconds,"R"..time(),"*.mod.hud:write(\""..text.."\",\"dingding.mp3\")")
end

function Me:list()
	for i=1,999,1 do
		if schedule[i].at>=9999999999 then break end
		if schedule[i] then mod.f:Print(i..": "..(schedule[i].at-time()).." id="..(schedule[i].id or "nil")..": "..(schedule[i].script or "nil"))
		else mod.f:Print(i..": unexistant entry") end
	end
	mod.f:Print(L.msg.endoflist)
end

function Me:getShowFPS() return db.scheduler.fps.show end
function Me:getFPSmin() return db.scheduler.fps.min end
function Me:getFPSmax() return db.scheduler.fps.max end
function Me:setShowFPS(set) 
	db.scheduler.fps.show=set 
	if not set then widget.fpstext:SetText("") end
end
function Me:setFPSmin(set) db.scheduler.fps.min=set end
function Me:setFPSmax(set) db.scheduler.fps.max=set end